package com.fjhx.email.service;

import com.fjhx.email.entity.dto.GetMessagePageDto;
import com.fjhx.email.entity.dto.MailboxInfo;
import com.fjhx.email.entity.dto.SetSeenDto;
import com.fjhx.email.entity.vo.MessageDetailVo;
import com.fjhx.email.entity.vo.MessageVo;
import com.fjhx.email.utils.PageWrapper;
import com.sun.mail.imap.IMAPMessage;

import javax.mail.MessagingException;
import java.io.IOException;
import java.util.List;

public interface IMailService {

    /**
     * 获取邮箱信息
     */
    List<MailboxInfo> getMailboxInfoListByUserId(List<Long> userIdList, Integer mailType);

    /**
     * 获取用户邮箱列表
     */
    PageWrapper<MessageVo> getMessagePage(GetMessagePageDto dto);

    /**
     * 获取邮件详情
     */
    MessageDetailVo getMessageDetail(GetMessagePageDto dto);

    /**
     * 获取文件夹未读数据
     */
    void setUnreadMessageCount(List<MailboxInfo> mailboxInfoList);

    /**
     * 设置已读
     */
    void setSeen(String host, String user, String password, SetSeenDto dto) throws MessagingException;

    /**
     * 取消已读
     */
    void cancelSeen(String host, String user, String password, SetSeenDto dto) throws MessagingException;

    void saveMessageDetail(Long messageId, MessageDetailVo messageDetailVo, Integer type);

    void setAddress(IMAPMessage message, MessageDetailVo messageDetailVo) throws MessagingException;

    void setTextAndAttachment(IMAPMessage message, MessageDetailVo vo) throws MessagingException, IOException;
}
